redis = require('redis').createClient();
queue = require('redis').createClient();
exec = require('child_process').exec

var worker = function(err, res) {
    res = JSON.parse(res[1]);

    var packet = {}
    console.log("name: %s, params: %s", res.name, res.params);
    switch(res.name) {
    case "run":
        exec(res.params, function (err, stdout, stderr) {
            packet["job_id"] = res.job_id;
            packet["response"] = stdout;
            redis.rpush("yajq:done:"+res.caller_id, JSON.stringify(packet));
        });
        break;
    case "echo":
        packet["job_id"] = res.job_id;
        packet["response"] = res.params.data;
        redis.rpush("yajq:done:"+res.caller_id, JSON.stringify(packet));
        break;;
    case "bad_call":
        packet["job_id"] = res.job_id;
        packet["error"]  = "shit happened!";
        redis.rpush("yajq:done:"+res.caller_id, JSON.stringify(packet));
        break;
    case "fire_and_forget":
        // do nothing!
        break;
    default:
        break;
    }
    queue.blpop('yajq:jobs', 0, worker);
}

queue.blpop('yajq:jobs', 0, worker);